<check-input>
<input type="checkbox" id="{ opts.tagid }" name="{name}"  data-group="{dataGroup}" data-idx="{dataIdx}" checked="{ opts.checkflg == true || opts.checkflg == 'true' }" onclick="{ onclickHandler }" onfocus={focusFunc} onblur={blurFunc}>
<label for="{ opts.tagid }" value="{value}" class="{lblCss}" tabIndex="0">{value}</label>
<script>
	this.id = opts.tagid;
	this.name = (opts.name) ? opts.name : opts.tagid;
	this.value = opts.value;
	this.checked = (opts.checkflg == "true");
	this.onclickfunc = opts.onclickfunc;
	this.lblCss = "checkbox" + (opts.css ? ' ' + opts.css : '');
	this.dataGroup = opts.dataGroup;
	this.dataIdx = opts.dataIdx;
	
	this.dataattr = opts.dataattr;

	if (opts.value == null) {
		this.value = '\u00A0';
		this.lblCss += " noLabel";
	}

	onclickHandler(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		this.checked = !this.checked;
		if (opts.onclickfunc != null) {
			opts.onclickfunc(e);
		}
	}
	
	this.on('updated', function() {
		this.checked = (opts.checkflg == "true");
		setDataObj(opts.tagid, opts);
	});

	// フォーカスin時の値を保持
	this._tmpVal = this.value;
	
	/**
	 * フォーカスin時の処理
	 */
	focusFunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		this._tmpVal = $('#' + this.id).val();
	}

	/**
	 * フォーカスout時の処理
	 */
	blurFunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		var aftVal = $('#' + this.id).val();
		if (this._tmpVal != aftVal) {
			updFlg = true;
			$('#' + this.id).attr('data-updflg', '1');
		}
	}

	/**
	 * キーがデータ属性に使用するキーかどうか
	 */
	function isDataAttrKey(key) {
		return key.startsWith('data-');
	}
	
	/**
	 * データ属性を設定する
	 */
	function setDataObj(id, val, forcingFlg) {
		Object.keys(val).forEach(function(key) {
			if (isDataAttrKey(camelToSnake(key, '-')) || forcingFlg) {
				var v = val[key];
				if (typeof v === 'object') {
					setDataObj(id, v, true);
				} else {
					$('#' + id).attr(forcingFlg ? 'data-' + key : camelToSnake(key, '-'), v);
				}
			}
		});
	}
</script>
</check-input>
